package com.yingying.tourist.web;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yingying.tourist.business.BusinessConstant;
import com.yingying.tourist.common.Util;
import com.yingying.tourist.domain.Question;
import com.yingying.tourist.domain.User;
import com.yingying.tourist.exception.ErrorCode;
import com.yingying.tourist.result.MessageResult;
import com.yingying.tourist.service.QuestionService;
import com.yingying.tourist.service.UserService;
import com.yingying.tourist.vo.QuestionVo;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class QuestionController {

    @Autowired
    private QuestionService questionService;

    @Autowired
    private UserService userService;

    @GetMapping("question/pick")
    public MessageResult<QuestionVo> question(String openid, String pickOne, String pickTwo, String pickThird, String pickFourth){
        if (Util.isNull(openid) || Util.isNull(pickOne) || Util.isNull(pickTwo) || Util.isNull(pickThird) || Util.isNull(pickFourth)) {
            return new MessageResult<QuestionVo>().failure(ErrorCode.PARAMETERS_ERROR);
        }
        QuestionVo questionVo = new QuestionVo();
        String pick = pickOne + pickTwo + pickThird;
        EntityWrapper<Question> questionWrapper = new EntityWrapper<>();
        questionWrapper.eq("question_path", pick);
        Question question = questionService.selectOne(questionWrapper);
        EntityWrapper<User> userWrapper = new EntityWrapper<>();
        userWrapper.eq("openid", openid);
        User user = userService.selectOne(userWrapper);
        BeanUtils.copyProperties(question, questionVo);
        questionVo.setResultDescribe(BusinessConstant.describeMap.get(Util.getRandomInt(1,16)));
        questionVo.setResultIdentity(BusinessConstant.Identity.getValue(pickFourth));
        questionVo.setNickname(user.getNickname());
        return new MessageResult<QuestionVo>().ok(questionVo);
    }
}
